/* File:      flrshdirect.P
**
** Author(s): Guizhen Yang 
**
** Contact:   xsb-contact@cs.sunysb.edu
**
** Copyright (C) The Research Foundation of SUNY, 1999-2001
**
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
** 
** 
*/


:- compiler_options([xpp_on]).

#include "flora_terms.flh"


%%:- import flora_shdefine_prolog/2 from flrprolog.

:- import flora_shdefine_firstorder/2 from flrfirstorder.

:- import flora_shdefine_operator/3 from flroperator.

:- import flora_shdefine_arguments/3 from flrarguments.




/*****************************************************************************
  fllibshdirect
*****************************************************************************/
%%fllibshdirect(FL_PROLOG,Funct,Arity) :-
%%	flora_shdefine_prolog(Funct,Arity).

fllibshdirect(FL_FIRSTORDER,Funct,Arity) :-
	flora_shdefine_firstorder(Funct,Arity).

fllibshdirect(FL_OP,Preced,Assoc,Op) :-
	flora_shdefine_operator(Preced,Assoc,Op).

fllibshdirect(FL_ARGUMENTS,Funct,Arity,Args) :-
	flora_shdefine_arguments(Funct,Arity,Args).
